; Copyright (C) 1993,96 Inujima, Masaru
; This file is a part of rhizhome/pi, Qfwfq opus 1

; Permission to use, copy, modify, and/or distribute this
; program for any purpose is hereby granted, provided that
; this copyright notice appears in all copies made of this
; program.
; Fees for distribution or use of this program or derived
; materials may only be charged with prior written consent
; of the author.
; This program is provided "as is" without any express or
; implied warranty.

;;;; @(#)$Id: utils.scm,v 1.2 1996/10/10 08:27:10 qfwfq Exp $
; $Log: utils.scm,v $
; Revision 1.2  1996/10/10 08:27:10  qfwfq
; Ported to Win32 environment.
;
; Revision 1.1  1996/09/06 06:12:41  qfwfq
; Version 0.20 unix revision is up.
;

(rp:load-into-compiler-environment "config.scm")

(define (rp:basename name suffix)
  (let
    ((rindex
       (lambda (string char)
	 (let loop ((i (- (string-length string) 1)))
	   (cond ((< i 0) #f)
		 ((char=? (string-ref string i) char) i)
		 (else (loop (- i 1))))))))
    (let ((slash (rindex name (cm-path-separate-char))) (len (string-length name)))
      (let ((blen (if suffix (- len (string-length suffix)) len)))
	(substring name
	  (if slash (+ slash 1) 0)
	  (if (and suffix (< 0 blen) (string=? suffix (substring name blen len)))
	    blen len))))))

(define rp:emit-code
  (let ((tab-char (integer->char 9)))
    (lambda (port format . args)
      (let ((n (string-length format))
	    (format-error (lambda () (cause-error "Internal: format string error" format)))
	    (get-arg
	      (lambda ()
		(if (null? args) (cause-error "Internal: to few arguments for format string" format))
		(let ((val (car args))) (set! args (cdr args)) val))))
	(do ((i 0 (+ i 1)))
	  ((eqv? i n)
	   (if (not (null? args)) (cause-error "Internal: to many arguments for fomat string" format)))
	  (let ((c (string-ref format i)))
	    (if (not (eqv? c #\~)) (display c port)
	      (begin
		(set! i (+ i 1))
		(if (eqv? i n) (format-error))
		(case (string-ref format i)
		  ((#\T) (display tab-char port))
		  ((#\~) (display #\~ port))
		  ((#\A) (display (get-arg) port))
		  ((#\V) ((get-arg)))
		  (else (format-error)))))))))))

(define (rp:emit-line port format . args)
  (apply rp:emit-code port format args) (newline port))
