;;;; @(#)$Id: slibinit.scm,v 1.1 1993/11/08 14:09:52 qfwfq Exp $
; $Log: slibinit.scm,v $
; Revision 1.1  1993/11/08 14:09:52  qfwfq
; Initial revision
;

; This file is derived from Template.scm in slib1d2. Here is the original
;copyright notice.

;------------------------------------------------------------------------------
;;;; Template for configuration of *features* for Scheme
;;; Copyright (C) 1991, 1992, 1993 Aubrey Jaffer.

;Permission to copy this software, to redistribute it, and to use it
;for any purpose is granted, subject to the following restrictions and
;understandings.

;1.  Any copy made of this software must include this copyright notice
;in full.

;2.  I have made no warrantee or representation that the operation of
;this software will be error-free, and I am under no obligation to
;provide any services, by way of maintenance, update, or otherwise.

;3.  In conjunction with products arising from the use of this
;material, there shall be no use of my name in any advertising,
;promotional, or sales literature without prior written consent in
;each case.
;------------------------------------------------------------------------------

; The author of rhizome/pi does not claim that rhizome/pi works correctly
;with slib. GOOD LUCK and Happy Hacking!

;;; Change this to MSDOS if necessary.
(define (software-type) 'UNIX)

(define *features*
      '(
	rev4-report
	ieee-p1178
	rev4-optional-procedures
	multiarg/and-
	multiarg-apply
	rationalize
	delay
	with-file
	string-port
	transcript
	char-ready?
;	macro				;has R4RS high level macros
	eval
	ieee-floating-point
	full-continuation
	system
	getenv
	program-arguments
;	Xwindows			;X support
;	MSwindows			;MS-Windows support
	))

(define (program-arguments) (vector->list (rp:command-line-arguments)))

;;; (OUTPUT-PORT-WIDTH <port>)
(define (output-port-width . arg) 79)

;;; (CURRENT-ERROR-PORT)
(define current-error-port rp:current-error-port)

;;; (TMPNAM) makes a temporary file name.
(define tmpnam
  (let ((cntr 100))
    (lambda () (set! cntr (+ 1 cntr))
      (let ((tmp (string-append "slib_" (number->string cntr))))
	(if (file-exists? tmp) (tmpnam) tmp)))))

;;; (FILE-EXISTS? <string>) primitive

;;; (DELETE-FILE <string>)
(define (delete-file f) (system (string-append "rm " f)))

;;; FORCE-OUTPUT flushes any pending output on optional arg output port
;;; use this definition if your system doesn't have such a procedure.
(define (force-output . arg) #t)

;;; CALL-WITH-INPUT-STRING and CALL-WITH-OUTPUT-STRING are the string
;;; port versions of CALL-WITH-*PUT-FILE.
(define (call-with-output-string f)
  (let ((outsp (open-output-string)))
    (f outsp)
    (let ((s (get-output-string outsp)))
      (close-output-port outsp)
      s)))

(define (call-with-input-string s f)
  (let* ((insp (open-input-string s))
	 (res (f insp)))
    (close-input-port insp)
    res))

;;; CHAR-CODE-LIMIT is one greater than the largest integer which can
;;; be returned by CHAR->INTEGER.
(define char-code-limit 256)

;;; MOST-POSITIVE-FIXNUM is used in modular.scm
(define most-positive-fixnum #x1FFFFFFF)

;;; If your implementation provides eval SLIB:EVAL is single argument
;;; eval using the top-level (user) environment.
(define slib:eval eval)

;;; If your implementation provides R4RS macros:
;(define macro:eval slib:eval)
;(define macro:load load)

;;; define an error procedure for the library
(define (slib:error . x)
  (do ((x x (cdr x))) ((null? x) (error)) (display (car x))))

;;; define these as appropriate for your system.
(define slib:tab (integer->char 9))
(define slib:form-feed (integer->char 12))

;;; (implementation-vicinity) should be defined to be the pathname of
;;; the directory where any auxillary files to your Scheme
;;; implementation reside.

(define (implementation-vicinity)
  (case (software-type)
    ((UNIX)	 "/usr/local/src/scheme/")
    ((VMS)	"scheme$src:")
    ((MSDOS)	"C:\\scheme\\")))

;;; (library-vicinity) should be defined to be the pathname of the
;;; directory where files of Scheme library functions reside.

(define library-vicinity
  (let ((library-path
	 (or (and (memq 'getenv *features*)
		  (getenv "SCHEME_LIBRARY_PATH"))
;;; Uses this path if your scheme does not support GETENV.
	     (case (software-type)
	       ((UNIX) "/usr/local/lib/slib/")
	       ((VMS) "lib$scheme:")
	       ((MSDOS) "C:\\SLIB\\")
	       (else "")))))

    (lambda () library-path)))

(define scheme-file-suffix
  (let ((suffix (case (software-type)
		  ((NOSVE) "_scm")
		  (else ".scm"))))
    (lambda () suffix)))

(define in-vicinity string-append)

(load (in-vicinity (library-vicinity) "require" (scheme-file-suffix)))
